/*
 * Copyright (c) 1998,1999,2000,2003 Damien Miller.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* Sorts hosts and peers lists */

#ifndef _SORT_REPORT_H
#define _SORT_REPORT_H

#define SORT_NONE 					0
#define SORT_BYTES					1
#define SORT_BYTES_SENT 			2
#define SORT_BYTES_RECEIVED		3
#define SORT_PACKETS 				4
#define SORT_PACKETS_SENT  		5
#define SORT_PACKETS_RECEIVED 	6
#define SORT_CONNECTS				7
#define SORT_CONNECTS_SENT 		8
#define SORT_CONNECTS_RECEIVED	9
#define SORT_PEERS					10
#define SORT_HOSTNAME				11
#define SORT_IP_ADDR					12
#define SORT_FIRST_SEEN				13
#define SORT_LAST_SEEN				14
#define SORT_RANDOM					15

#define SORT_HOST_DEFAULT  		SORT_BYTES
#define SORT_PEER_DEFAULT  		SORT_BYTES

#include "report.h"

/* Sorts hosts table */
host_t	*sort_hosts(host_t *host_list, int host_sort_mode, int host_reverse);

/* Sort peers list */
peer_t	*sort_peers(peer_t *peer_list, int peer_sort_mode, int peer_reverse);

/* Sort all peer lists */
void sort_all_peers(host_t *h, int peer_sort_mode, int peer_reverse);

/* Parses textual host sort key into numeric identifier */
int parse_host_sort_mode(const char *sort_mode);

/* Parses textual peer sort key into numeric identifier */
int parse_peer_sort_mode(const char *sort_mode);

#endif /* _SORT_REPORT_H */
